VehicleFruitHud = {};
VehicleFruitHud.modDir = g_currentModDirectory;
VehicleFruitHud.settingsDir = getUserProfileAppPath().. "modSettings/VehicleFruitHud/";
VehicleFruitHud.metadata = {
	interface = " FS22 ...",
	title = " VehicleFruit Hud",
	notes = " setzt Name/Kapazität zusätzlich ins VehicleFruit Hud",
	author = " (by HappyLooser)",
	version = " v0.55 Beta",	
	datum = " 20.11.2018",
	update = " 30.11.2021",
	web = " no",
	info = " Link Freigabe,Änderungen,Kopien oder Code Benutzung ist ohne meine Zustimmung nicht erlaubt",
	"##Orginal Link Freigabe:"
};

function VehicleFruitHud:loadMap(name)	
	print("---loading".. tostring(VehicleFruitHud.metadata.title).. tostring(VehicleFruitHud.metadata.version).. tostring(VehicleFruitHud.metadata.author).. "---")
	if g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo ~= nil then return;end;
	generateFolders();
	--VehicleFruitHud.color = {255/255, 255/255, 0/255, 1.00};
	VehicleFruitHud.txtColor = "yellow";
	VehicleFruitHud.capacity = true;
	VehicleFruitHud.name = true;
	VehicleFruitHud.txtBold = true;
	VehicleFruitHud.txtSize = g_currentMission.hud.fillLevelsDisplay.fillLevelTextSize; --not active			
	VehicleFruitHud.hlDebugMode = false;	
	VehicleFruitHud:setGetCfg(true);	
	VehicleFruitHud:init();
	local color = g_currentMission.hl.getColor(VehicleFruitHud.txtColor, true);	
	FillLevelsDisplay.COLOR.FILL_LEVEL_TEXT = color;		
end;

function VehicleFruitHud:deleteMap()
	if g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo ~= nil then return;end;
	VehicleFruitHud:setGetCfg(false);	
end;

function VehicleFruitHud:mouseEvent(posX, posY, isDown, isUp, button)
end;

function VehicleFruitHud:keyEvent(unicode, sym, modifier, isDown)
	if g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo ~= nil then return;end;
	if VehicleFruitHud:get_hl("getIngameMap", {}, "getIngameMap") or VehicleFruitHud:get_hl("getFullSize", {true, true}, "getFullSize") then return;end;
	if VehicleFruitHud.hlDebugMode and Input.isKeyPressed(Input.KEY_f2)then		
		if g_currentMission.hl.debug ~= nil then
			local a=1;		
			for key,value in pairs(g_currentMission.hl.debug) do
				for key1,value1 in pairs(value) do			
					print(tostring(a).. ".hl_Debug Error at ".. tostring(key).. " = ".. tostring(value1))			
					a=a+1;
				end;
			end;
		else
			print("1.hl_Debug NOT Found Error at ".. tostring(VehicleFruitHud.metadata.title))
		end;
	end;	
end;

function VehicleFruitHud:update(dt)
	if g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo ~= nil then return;end;
	if VehicleFruitHud:get_hl("getIngameMap", {}, "getIngameMap") or VehicleFruitHud:get_hl("getFullSize", {true, true}, "getFullSize") then return;end;
	VehicleFruitHud:get_hl("update_timers", {dt, "VehicleFruitHud"}, "VehicleFruitHud:update");
	VehicleFruitHud:get_hl("updateRunMsg", {dt, "VehicleFruitHud"}, "VehicleFruitHud:update");
	if g_currentMission.hl.isMouseCursor then VehicleFruitHud:get_hl("mouseOnOff", {true,true,"VehicleFruitHud"}, "VehicleFruitHud:update");end;
end;

local test = true;
function VehicleFruitHud:draw(dt)
	if g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo ~= nil then return;end;	
	if VehicleFruitHud:get_hl("getIngameMap", {}, "getIngameMap") or VehicleFruitHud:get_hl("getFullSize", {true, true}, "getFullSize") then return;end;	
	VehicleFruitHud:get_hl("drawRunMsg", {"VehicleFruitHud"}, "VehicleFruitHud:draw");
	local isControlled = g_currentMission.controlledVehicle;
	if g_currentMission.hud.fillLevelsDisplay:getVisible() and g_currentMission.hud.fillLevelsDisplay.vehicle ~= nil and g_currentMission.hud.showVehicleSchema and isControlled and g_currentMission.hud.fillLevelsDisplay.vehicle == isControlled then
		setTextAlignment(0);		
		setTextColor(unpack(g_currentMission.hl.getColor(VehicleFruitHud.txtColor, true)));
		setTextBold(VehicleFruitHud.txtBold);		
		local foundHorse = false;
		local vehicle = nil;
		if VehicleFruitHud.visualFruitHorseHud then			
			vehicle = isControlled;			
			if vehicle ~= nil and vehicle.getIsControlled ~= nil and vehicle.getIsControlled(vehicle) and g_gameSettings.nickname == vehicle.getControllerName(vehicle) then
				foundHorse = vehicle.specializationsByName ~= nil and vehicle.specializationsByName.rideable ~= nil and vehicle.spec_rideable ~= nil and vehicle.spec_rideable.animal ~= nil;
			end;
		end;
		if foundHorse then			
			--VehicleFruitHorseHud:drawHud(vehicle);
		elseif g_currentMission.hud.fillLevelsDisplay.fillLevelBuffer ~= nil and type(g_currentMission.hud.fillLevelsDisplay.fillLevelBuffer) == "table" and #g_currentMission.hud.fillLevelsDisplay.fillLevelBuffer > 0 then
			local frameHeight = g_currentMission.hud.fillLevelsDisplay.frameHeight;
			local int = 0;
			for a=1, #g_currentMission.hud.fillLevelsDisplay.fillLevelBuffer do
				if g_currentMission.hud.fillLevelsDisplay.fillLevelBuffer[a] ~= nil then
					local capacity = g_currentMission.hud.fillLevelsDisplay.fillLevelBuffer[a].capacity or 0;
					local fillLevel = g_currentMission.hud.fillLevelsDisplay.fillLevelBuffer[a].fillLevel or 0;
					local txtHeight = getTextHeight(g_currentMission.hud.fillLevelsDisplay.fillLevelTextSize, tostring("Äg"));					
					local fillType = g_currentMission.hud.fillLevelsDisplay.fillLevelBuffer[a].fillType or 0;											
					local descFill = g_currentMission.fillTypeManager.fillTypes[fillType];					
					if descFill ~= nil then						
						local frame = g_currentMission.hud.fillLevelsDisplay.fillTypeFrames[fillType];
						if frame:getVisible() then							
							local posX, posY = frame:getPosition();
							local width = frame:getWidth();
							int = int+1;
							local name = descFill.title or descFill.name;							
							if capacity > 0 and VehicleFruitHud.capacity then 
								setTextAlignment(0);																
								renderText(g_currentMission.hud.fillLevelsDisplay.origX+(width/3), posY-txtHeight+(g_currentMission.hud.fillLevelsDisplay.frameOffsetY/2), g_currentMission.hud.fillLevelsDisplay.fillLevelTextSize, tostring(capacity));
							end;
							if fillLevel > 0 and VehicleFruitHud.name and not string.find(name, "Unknown") then
								setTextAlignment(2);
								if int == 1 then
									renderText(g_currentMission.hud.fillLevelsDisplay.origX+g_currentMission.hud.fillLevelsDisplay.firstFillTypeOffset, posY, g_currentMission.hud.fillLevelsDisplay.fillLevelTextSize, tostring(name));
								else
									renderText(g_currentMission.hud.fillLevelsDisplay.origX, posY, g_currentMission.hud.fillLevelsDisplay.fillLevelTextSize, tostring(name));
								end;								
							end;
						end;
					end;					
				end;				
			end;
		end;		
	end;
	--respect settings for other mods
	setTextAlignment(0);
	setTextColor(1, 1, 1, 1);
	setTextBold(false);
	--respect settings for other mods
end;
addModEventListener(VehicleFruitHud);

function VehicleFruitHud:get_hl(args, argsTable, errorTxtCall) --args hl table, argsTable a table with all args Values, errorTxt a Value for debug print
	local isOkay, result, argsError, errorTxt = nil,nil,nil,errorTxtCall;
	if VehicleFruitHud.hlDebugMode and (errorTxtCall == nil or type(errorTxtCall) ~= "string" or string.len(errorTxtCall) == 0) then errorTxt = "Unknown";end;
	local foundArgsError = false;
	if type(argsTable) == "table" or g_currentMission.hl[args] ~= nil or #argsTable > 0 then	
		isOkay, result = pcall(g_currentMission.hl[args], unpack(argsTable));
	else
		foundArgsError = true;
	end;
	if VehicleFruitHud.hlDebugMode and foundArgsError then isOkay=false;argsError="Unknown args or argsTable or argsTable = 0";end;		
	if VehicleFruitHud.hlDebugMode and (not isOkay or foundArgsError) then VehicleFruitHud:setDebug("VehicleFruitHudMod", args or "Unknown", errorTxt, argsError or "No args error", result or "NO result error");end;
	return result, isOkay;	
end;

function VehicleFruitHud:setDebug(argsMod, args1, errorTxt, args2, args3)	
	if g_currentMission.hl.debug == nil then g_currentMission.hl.debug = {};end;
	if g_currentMission.hl.debug[argsMod] == nil then g_currentMission.hl.debug[argsMod] = {};end;
	local errorString = "Trigger: ".. tostring(args1).. " -errorTxtCall: ".. tostring(errorTxt).. " -argsError: ".. tostring(args2).. " -resultError: ".. tostring(args3);
	local alreadyExists = false;
	if #g_currentMission.hl.debug[argsMod] == 0 then table.insert(g_currentMission.hl.debug[argsMod], tostring(errorString));else
		for key,value in pairs(g_currentMission.hl.debug[argsMod]) do			
			if tostring(value) == errorString and string.len(value) == string.len(errorString) then alreadyExists=true;break;end;			
		end;		
		if not alreadyExists then table.insert(g_currentMission.hl.debug[argsMod], tostring(errorString));end;
	end;	
end;

function generateFolders()
	createFolder(getUserProfileAppPath().. "modSettings/");
	createFolder(VehicleFruitHud.settingsDir);		
end;

function VehicleFruitHud:init()
	VehicleFruitHud:setGetCfg(false);
	source(VehicleFruitHud.modDir.."_hl.lua");
	--source(VehicleFruitHud.modDir.."VehicleFruitHorseHud.lua");	
end;

function VehicleFruitHud:setGetCfg(loadCfg)
	if g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo ~= nil then return;end;
	local file = VehicleFruitHud.settingsDir.. "vehicleFruitHudSettings.xml";
	local Xml = nil;
	if not fileExists(file) or not loadCfg then
		Xml = createXMLFile("VehicleFruitHud_XML", file, "vehicleFruitHudSettings");
		local groupNameTag = ("vehicleFruitHudSettings.global(%d)"):format(0);		
		setXMLBool(Xml, groupNameTag.. "#capacity", VehicleFruitHud.capacity);
		setXMLBool(Xml, groupNameTag.. "#name", VehicleFruitHud.name);
		setXMLBool(Xml, groupNameTag.. "#txtBold", VehicleFruitHud.txtBold);		
		setXMLString(Xml, groupNameTag.. "#txtColor", VehicleFruitHud.txtColor);		
		
		--setXMLBool(Xml, groupNameTag.. "#hlDebugMode", VehicleFruitHud.hlDebugMode);
		
		saveXMLFile(Xml);
	else	
		Xml = loadXMLFile("VehicleFruitHud_XML", file, "vehicleFruitHudSettings");
		local groupNameTag = ("vehicleFruitHudSettings.global(%d)"):format(0);		
		if getXMLBool(Xml, groupNameTag.. "#capacity") ~= nil then VehicleFruitHud.capacity = getXMLBool(Xml, groupNameTag.. "#capacity");end;
		if getXMLBool(Xml, groupNameTag.. "#name") ~= nil then VehicleFruitHud.name = getXMLBool(Xml, groupNameTag.. "#name");end;
		if getXMLBool(Xml, groupNameTag.. "#txtBold") ~= nil then VehicleFruitHud.txtBold = getXMLBool(Xml, groupNameTag.. "#txtBold");end;		
		if getXMLString(Xml, groupNameTag.. "#txtColor") ~= nil then VehicleFruitHud.txtColor = getXMLString(Xml, groupNameTag.. "#txtColor");end;	
				
		--if getXMLBool(Xml, groupNameTag.. "#hlDebugMode") ~= nil then VehicleFruitHud.hlDebugMode = getXMLBool(Xml, groupNameTag.. "#hlDebugMode");end;
		
	end;	
end;